> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get usage statistics report

> Data from the past hour may not reflect the full set of statistics.
For the most complete and accurate results, we recommend accessing the data at least one hour after the
relevant time period. Updates are generally available within a 24-hour window, though timing can vary.
Scheduled maintenance or other exceptions may occasionally cause delays beyond 24 hours.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml post /cloud/v1/usage_report
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-14T07:00:22.640261+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v1/usage_report:
    post:
      tags:
        - Cost Reports
      summary: Get usage statistics report
      description: >-
        Data from the past hour may not reflect the full set of statistics.

        For the most complete and accurate results, we recommend accessing the
        data at least one hour after the

        relevant time period. Updates are generally available within a 24-hour
        window, though timing can vary.

        Scheduled maintenance or other exceptions may occasionally cause delays
        beyond 24 hours.
      operationId: UsageReportHandler.post
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UsageReportRequestSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UsageReportResponseSerializer'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from datetime import datetime
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            usage_report = client.cloud.usage_reports.get(
                time_from=datetime.fromisoformat("2023-01-01T00:00:00"),
                time_to=datetime.fromisoformat("2023-02-01T00:00:00"),
            )
            print(usage_report.count)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\t\"time\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tusageReport, err := client.Cloud.UsageReports.Get(context.TODO(), cloud.UsageReportGetParams{\n\t\tTimeFrom: time.Now(),\n\t\tTimeTo:   time.Now(),\n\t})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", usageReport.Count)\n}\n"
components:
  schemas:
    UsageReportRequestSerializer:
      additionalProperties: false
      example:
        limit: 50
        offset: 0
        order_by:
          - project.desc
        projects:
          - 16
          - 17
          - 18
          - 19
          - 20
        regions:
          - 4
          - 5
        schema_filter:
          field: flavor
          type: instance
          values:
            - g1-standard-1-2
        tags:
          condition_type: OR
          conditions:
            - key: os_version
              strict: true
              value: '22.04'
            - key: os_version
              strict: true
              value: '23.04'
        time_from: '2019-08-01T00:00:00'
        time_to: '2019-09-15T00:00:00'
        types:
          - egress_traffic
          - instance
      examples:
        - limit: 50
          offset: 0
          order_by:
            - project.desc
          projects:
            - 16
            - 17
            - 18
            - 19
            - 20
          regions:
            - 4
            - 5
          schema_filter:
            field: flavor
            type: instance
            values:
              - g1-standard-1-2
          tags:
            condition_type: OR
            conditions:
              - key: os_version
                strict: true
                value: '22.04'
              - key: os_version
                strict: true
                value: '23.04'
          time_from: '2019-08-01T00:00:00'
          time_to: '2019-09-15T00:00:00'
          types:
            - egress_traffic
            - instance
      properties:
        enable_last_day:
          default: false
          description: >-
            Expenses for the last specified day are taken into account. As the
            default, False.
          example: false
          examples:
            - false
          title: Enable Last Day
          type: boolean
        limit:
          default: 10
          description: The response resources limit. Defaults to 10.
          example: 10
          examples:
            - 10
          exclusiveMinimum: 0
          title: Limit
          type: integer
        offset:
          default: 0
          description: The response resources offset.
          example: 0
          examples:
            - 0
          minimum: 0
          title: Offset
          type: integer
        order_by:
          default:
            - project.asc
          description: List of sorting criteria in 'field.direction' format.
          example:
            - project.asc
            - region.desc
          examples:
            - - project.asc
              - region.desc
          items:
            $ref: '#/components/schemas/CostReportOrderByChoices'
          title: Order By
          type: array
        projects:
          anyOf:
            - items:
                type: integer
              type: array
            - type: 'null'
          default: null
          description: List of project IDs
          examples:
            - - 16
              - 17
              - 18
              - 19
              - 20
          title: Projects
        regions:
          description: List of region IDs.
          example:
            - 1
            - 2
            - 3
          examples:
            - - 1
              - 2
              - 3
          items:
            type: integer
          title: Regions
          type: array
        schema_filter:
          description: Extended filter for field filtering.
          discriminator:
            mapping:
              ai_cluster:
                $ref: '#/components/schemas/SchemaFilterAiClusterSerializer'
              ai_virtual_cluster:
                $ref: '#/components/schemas/SchemaFilterAiVirtualClusterSerializer'
              backup:
                $ref: '#/components/schemas/SchemaFilterBackupSerializer'
              baremetal:
                $ref: '#/components/schemas/SchemaFilterBaremetalSerializer'
              basic_vm:
                $ref: '#/components/schemas/SchemaFilterBasicVmSerializer'
              containers:
                $ref: '#/components/schemas/SchemaFilterContainersSerializer'
              dbaas_postgresql_connection_pooler:
                $ref: >-
                  #/components/schemas/SchemaFilterDBAASPostgreSQLPoolerSerializer
              dbaas_postgresql_cpu:
                $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLCPUSerializer'
              dbaas_postgresql_memory:
                $ref: >-
                  #/components/schemas/SchemaFilterDBAASPostgreSQLMemorySerializer
              dbaas_postgresql_public_network:
                $ref: >-
                  #/components/schemas/SchemaFilterDBAASPostgreSQLPublicNetworkSerializer
              dbaas_postgresql_volume:
                $ref: >-
                  #/components/schemas/SchemaFilterDBAASPostgreSQLVolumeSerializer
              egress_traffic:
                $ref: '#/components/schemas/SchemaFilterEgressTrafficSerializer'
              external_ip:
                $ref: '#/components/schemas/SchemaFilterExternalIpSerializer'
              file_share:
                $ref: '#/components/schemas/SchemaFilterFileShareSerializer'
              floatingip:
                $ref: '#/components/schemas/SchemaFilterFloatingIpSerializer'
              functions:
                $ref: '#/components/schemas/SchemaFilterFunctionsSerializer'
              functions_calls:
                $ref: '#/components/schemas/SchemaFilterFunctionsCallsSerializer'
              functions_traffic:
                $ref: '#/components/schemas/SchemaFilterFunctionsTrafficSerializer'
              image:
                $ref: '#/components/schemas/SchemaFilterImageSerializer'
              inference:
                $ref: '#/components/schemas/SchemaFilterInferenceSerializer'
              instance:
                $ref: '#/components/schemas/SchemaFilterInstanceSerializer'
              load_balancer:
                $ref: '#/components/schemas/SchemaFilterLoadBalancerSerializer'
              log_index:
                $ref: '#/components/schemas/SchemaFilterLogIndexSerializer'
              snapshot:
                $ref: '#/components/schemas/SchemaFilterSnapshotSerializer'
              volume:
                $ref: '#/components/schemas/SchemaFilterVolumeSerializer'
            propertyName: type
          examples:
            - field: flavor
              type: instance
              values:
                - g1-standard-1-2
          oneOf:
            - $ref: '#/components/schemas/SchemaFilterSnapshotSerializer'
            - $ref: '#/components/schemas/SchemaFilterInstanceSerializer'
            - $ref: '#/components/schemas/SchemaFilterAiClusterSerializer'
            - $ref: '#/components/schemas/SchemaFilterAiVirtualClusterSerializer'
            - $ref: '#/components/schemas/SchemaFilterBasicVmSerializer'
            - $ref: '#/components/schemas/SchemaFilterBaremetalSerializer'
            - $ref: '#/components/schemas/SchemaFilterVolumeSerializer'
            - $ref: '#/components/schemas/SchemaFilterFileShareSerializer'
            - $ref: '#/components/schemas/SchemaFilterImageSerializer'
            - $ref: '#/components/schemas/SchemaFilterFloatingIpSerializer'
            - $ref: '#/components/schemas/SchemaFilterEgressTrafficSerializer'
            - $ref: '#/components/schemas/SchemaFilterLoadBalancerSerializer'
            - $ref: '#/components/schemas/SchemaFilterExternalIpSerializer'
            - $ref: '#/components/schemas/SchemaFilterBackupSerializer'
            - $ref: '#/components/schemas/SchemaFilterLogIndexSerializer'
            - $ref: '#/components/schemas/SchemaFilterFunctionsSerializer'
            - $ref: '#/components/schemas/SchemaFilterFunctionsCallsSerializer'
            - $ref: '#/components/schemas/SchemaFilterFunctionsTrafficSerializer'
            - $ref: '#/components/schemas/SchemaFilterContainersSerializer'
            - $ref: '#/components/schemas/SchemaFilterInferenceSerializer'
            - $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLVolumeSerializer'
            - $ref: >-
                #/components/schemas/SchemaFilterDBAASPostgreSQLPublicNetworkSerializer
            - $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLCPUSerializer'
            - $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLMemorySerializer'
            - $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLPoolerSerializer'
          title: Schema Filter
        sorting:
          default:
            - project: asc
          deprecated: true
          description: >-
            (DEPRECATED Use 'order_by' instead) List of sorting filters (JSON
            objects) fields: project. directions: asc, desc.
          items:
            $ref: '#/components/schemas/UsageReportSortingRequestSerializer'
          title: Sorting
          type: array
        tags:
          $ref: '#/components/schemas/TagsFilterSerializer'
          description: Filter by tags
          examples:
            - condition_type: OR
              conditions:
                - key: os_version
                  strict: true
                  value: '22.04'
                - key: os_version
                  strict: true
                  value: '23.04'
        time_from:
          description: >-
            The start date of the report period (ISO 8601). The report starts
            from the beginning of this day in UTC.
          example: '2023-01-01T00:00:00Z'
          examples:
            - '2023-01-01T00:00:00Z'
          format: date-time
          title: Time From
          type: string
        time_to:
          description: >-
            The end date of the report period (ISO 8601). The report ends just
            before the beginning of this day in UTC.
          example: '2023-02-01T00:00:00Z'
          examples:
            - '2023-02-01T00:00:00Z'
          format: date-time
          title: Time To
          type: string
        types:
          description: List of resource types to be filtered in the report.
          example:
            - egress_traffic
            - instance
          examples:
            - - egress_traffic
              - instance
          items:
            $ref: '#/components/schemas/PrebillingResourceTypes'
          title: Types
          type: array
      required:
        - time_from
        - time_to
      title: UsageReportRequestSerializer
      type: object
    UsageReportResponseSerializer:
      properties:
        count:
          description: Total count of the resources
          example: 1
          examples:
            - 1
          minimum: 0
          title: Count
          type: integer
        resources:
          items:
            discriminator:
              mapping:
                ai_cluster:
                  $ref: '#/components/schemas/ResourceAiClusterSerializer'
                ai_virtual_cluster:
                  $ref: '#/components/schemas/ResourceAiVirtualClusterSerializer'
                backup:
                  $ref: '#/components/schemas/ResourceBackupSerializer'
                baremetal:
                  $ref: '#/components/schemas/ResourceBaremetalSerializer'
                basic_vm:
                  $ref: '#/components/schemas/ResourceBasicVmSerializer'
                containers:
                  $ref: '#/components/schemas/ResourceContainerSerializer'
                dbaas_postgresql_connection_pooler:
                  $ref: '#/components/schemas/ResourceDBAASPostgreSQLPoolerSerializer'
                dbaas_postgresql_cpu:
                  $ref: '#/components/schemas/ResourceDBAASPostgreSQLCPUSerializer'
                dbaas_postgresql_memory:
                  $ref: '#/components/schemas/ResourceDBAASPostgreSQLMemorySerializer'
                dbaas_postgresql_public_network:
                  $ref: >-
                    #/components/schemas/ResourceDBAASPostgreSQLPublicNetworkSerializer
                dbaas_postgresql_volume:
                  $ref: '#/components/schemas/ResourceDBAASPostgreSQLVolumeSerializer'
                egress_traffic:
                  $ref: '#/components/schemas/ResourceEgressTrafficSerializer'
                external_ip:
                  $ref: '#/components/schemas/ResourceExternalIpSerializer'
                file_share:
                  $ref: '#/components/schemas/ResourceFileShareSerializer'
                floatingip:
                  $ref: '#/components/schemas/ResourceFloatingIpSerializer'
                functions:
                  $ref: '#/components/schemas/ResourceFunctionsSerializer'
                functions_calls:
                  $ref: '#/components/schemas/ResourceFunctionCallsSerializer'
                functions_traffic:
                  $ref: '#/components/schemas/ResourceFunctionEgressTrafficSerializer'
                image:
                  $ref: '#/components/schemas/ResourceImagesSerializer'
                inference:
                  $ref: '#/components/schemas/ResourceInferenceSerializer'
                instance:
                  $ref: '#/components/schemas/ResourceInstanceSerializer'
                load_balancer:
                  $ref: '#/components/schemas/ResourceLoadBalancerSerializer'
                log_index:
                  $ref: '#/components/schemas/ResourceLogIndexSerializer'
                snapshot:
                  $ref: '#/components/schemas/ResourceSnapshotSerializer'
                volume:
                  $ref: '#/components/schemas/ResourceVolumeSerializer'
              propertyName: type
            oneOf:
              - $ref: '#/components/schemas/ResourceAiClusterSerializer'
              - $ref: '#/components/schemas/ResourceAiVirtualClusterSerializer'
              - $ref: '#/components/schemas/ResourceBaremetalSerializer'
              - $ref: '#/components/schemas/ResourceBasicVmSerializer'
              - $ref: '#/components/schemas/ResourceBackupSerializer'
              - $ref: '#/components/schemas/ResourceContainerSerializer'
              - $ref: '#/components/schemas/ResourceEgressTrafficSerializer'
              - $ref: '#/components/schemas/ResourceExternalIpSerializer'
              - $ref: '#/components/schemas/ResourceFileShareSerializer'
              - $ref: '#/components/schemas/ResourceFloatingIpSerializer'
              - $ref: '#/components/schemas/ResourceFunctionsSerializer'
              - $ref: '#/components/schemas/ResourceFunctionCallsSerializer'
              - $ref: '#/components/schemas/ResourceFunctionEgressTrafficSerializer'
              - $ref: '#/components/schemas/ResourceImagesSerializer'
              - $ref: '#/components/schemas/ResourceInferenceSerializer'
              - $ref: '#/components/schemas/ResourceInstanceSerializer'
              - $ref: '#/components/schemas/ResourceLoadBalancerSerializer'
              - $ref: '#/components/schemas/ResourceLogIndexSerializer'
              - $ref: '#/components/schemas/ResourceSnapshotSerializer'
              - $ref: '#/components/schemas/ResourceVolumeSerializer'
              - $ref: '#/components/schemas/ResourceDBAASPostgreSQLPoolerSerializer'
              - $ref: '#/components/schemas/ResourceDBAASPostgreSQLMemorySerializer'
              - $ref: >-
                  #/components/schemas/ResourceDBAASPostgreSQLPublicNetworkSerializer
              - $ref: '#/components/schemas/ResourceDBAASPostgreSQLCPUSerializer'
              - $ref: '#/components/schemas/ResourceDBAASPostgreSQLVolumeSerializer'
          title: Resources
          type: array
        totals:
          items:
            discriminator:
              mapping:
                ai_cluster:
                  $ref: '#/components/schemas/TotalAiClusterReportItemSerializer'
                ai_virtual_cluster:
                  $ref: >-
                    #/components/schemas/TotalAiVirtualClusterReportItemSerializer
                baremetal:
                  $ref: '#/components/schemas/TotalBaremetalReportItemSerializer'
                basic_vm:
                  $ref: '#/components/schemas/TotalBasicVmReportItemSerializer'
                containers:
                  $ref: '#/components/schemas/TotalContainerReportItemSerializer'
                dbaas_postgresql_connection_pooler:
                  $ref: >-
                    #/components/schemas/TotalDBAASPostgreSQLPoolerReportItemSerializer
                dbaas_postgresql_cpu:
                  $ref: >-
                    #/components/schemas/TotalDBAASPostgreSQLCPUReportItemSerializer
                dbaas_postgresql_memory:
                  $ref: >-
                    #/components/schemas/TotalDBAASPostgreSQLMemoryReportItemSerializer
                dbaas_postgresql_public_network:
                  $ref: >-
                    #/components/schemas/TotalDBAASPostgreSQLPublicNetworkReportItemSerializer
                dbaas_postgresql_volume:
                  $ref: >-
                    #/components/schemas/TotalDBAASPostgreSQLVolumeReportItemSerializer
                egress_traffic:
                  $ref: '#/components/schemas/TotalEgressTrafficReportItemSerializer'
                external_ip:
                  $ref: '#/components/schemas/TotalExternalIpReportItemSerializer'
                file_share:
                  $ref: '#/components/schemas/TotalFileShareReportItemSerializer'
                floatingip:
                  $ref: '#/components/schemas/TotalFloatingIpReportItemSerializer'
                functions:
                  $ref: '#/components/schemas/TotalFunctionsReportItemSerializer'
                functions_calls:
                  $ref: '#/components/schemas/TotalFunctionCallsReportItemSerializer'
                functions_traffic:
                  $ref: >-
                    #/components/schemas/TotalFunctionEgressTrafficReportItemSerializer
                image:
                  $ref: '#/components/schemas/TotalImagesReportItemSerializer'
                inference:
                  $ref: '#/components/schemas/TotalInferenceReportItemSerializer'
                instance:
                  $ref: '#/components/schemas/TotalInstanceReportItemSerializer'
                load_balancer:
                  $ref: '#/components/schemas/TotalLoadBalancerReportItemSerializer'
                log_index:
                  $ref: '#/components/schemas/TotalLogIndexReportItemSerializer'
                snapshot:
                  $ref: '#/components/schemas/TotalSnapshotReportItemSerializer'
                volume:
                  $ref: '#/components/schemas/TotalVolumeReportItemSerializer'
              propertyName: type
            oneOf:
              - $ref: '#/components/schemas/TotalAiClusterReportItemSerializer'
              - $ref: '#/components/schemas/TotalAiVirtualClusterReportItemSerializer'
              - $ref: '#/components/schemas/TotalBaremetalReportItemSerializer'
              - $ref: '#/components/schemas/TotalBasicVmReportItemSerializer'
              - $ref: '#/components/schemas/TotalContainerReportItemSerializer'
              - $ref: '#/components/schemas/TotalEgressTrafficReportItemSerializer'
              - $ref: '#/components/schemas/TotalExternalIpReportItemSerializer'
              - $ref: '#/components/schemas/TotalFileShareReportItemSerializer'
              - $ref: '#/components/schemas/TotalFloatingIpReportItemSerializer'
              - $ref: '#/components/schemas/TotalFunctionsReportItemSerializer'
              - $ref: '#/components/schemas/TotalFunctionCallsReportItemSerializer'
              - $ref: >-
                  #/components/schemas/TotalFunctionEgressTrafficReportItemSerializer
              - $ref: '#/components/schemas/TotalImagesReportItemSerializer'
              - $ref: '#/components/schemas/TotalInferenceReportItemSerializer'
              - $ref: '#/components/schemas/TotalInstanceReportItemSerializer'
              - $ref: '#/components/schemas/TotalLoadBalancerReportItemSerializer'
              - $ref: '#/components/schemas/TotalLogIndexReportItemSerializer'
              - $ref: '#/components/schemas/TotalSnapshotReportItemSerializer'
              - $ref: '#/components/schemas/TotalVolumeReportItemSerializer'
              - $ref: >-
                  #/components/schemas/TotalDBAASPostgreSQLPoolerReportItemSerializer
              - $ref: >-
                  #/components/schemas/TotalDBAASPostgreSQLMemoryReportItemSerializer
              - $ref: >-
                  #/components/schemas/TotalDBAASPostgreSQLPublicNetworkReportItemSerializer
              - $ref: >-
                  #/components/schemas/TotalDBAASPostgreSQLCPUReportItemSerializer
              - $ref: >-
                  #/components/schemas/TotalDBAASPostgreSQLVolumeReportItemSerializer
          title: Totals
          type: array
      required:
        - count
        - resources
        - totals
      title: UsageReportResponseSerializer
      type: object
    CostReportOrderByChoices:
      enum:
        - billing_value.asc
        - billing_value.desc
        - first_seen.asc
        - first_seen.desc
        - last_name.asc
        - last_name.desc
        - last_seen.asc
        - last_seen.desc
        - project.asc
        - project.desc
        - region.asc
        - region.desc
        - type.asc
        - type.desc
      title: CostReportOrderByChoices
      type: string
    SchemaFilterAiClusterSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterAiClusterEnum'
          description: Field name to filter by
          examples:
            - flavor
        type:
          const: ai_cluster
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - bm3-ai-1xlarge-h100-80-8
          examples:
            - - bm3-ai-1xlarge-h100-80-8
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterAiClusterSerializer
      type: object
    SchemaFilterAiVirtualClusterSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterAiVirtualClusterEnum'
          description: Field name to filter by
          examples:
            - flavor
        type:
          const: ai_virtual_cluster
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - g3-ai-32-192-1500-l40s-48-1
          examples:
            - - g3-ai-32-192-1500-l40s-48-1
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterAiVirtualClusterSerializer
      type: object
    SchemaFilterBackupSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterBackupEnum'
          description: Field name to filter by
          examples:
            - last_size
        type:
          const: backup
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - '10'
          examples:
            - - '10'
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterBackupSerializer
      type: object
    SchemaFilterBaremetalSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterInstanceEnum'
          description: Field name to filter by
          examples:
            - flavor
        type:
          const: baremetal
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - bm2-hf-medium
          examples:
            - - bm2-hf-medium
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterBaremetalSerializer
      type: object
    SchemaFilterBasicVmSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterInstanceEnum'
          description: Field name to filter by
          examples:
            - flavor
        type:
          const: basic_vm
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - g2s-shared-1-2-25
          examples:
            - - g2s-shared-1-2-25
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterBasicVmSerializer
      type: object
    SchemaFilterContainersSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterContainersEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: containers
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterContainersSerializer
      type: object
    SchemaFilterDBAASPostgreSQLPoolerSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: dbaas_postgresql_connection_pooler
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterDBAASPostgreSQLPoolerSerializer
      type: object
    SchemaFilterDBAASPostgreSQLCPUSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: dbaas_postgresql_cpu
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterDBAASPostgreSQLCPUSerializer
      type: object
    SchemaFilterDBAASPostgreSQLMemorySerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: dbaas_postgresql_memory
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterDBAASPostgreSQLMemorySerializer
      type: object
    SchemaFilterDBAASPostgreSQLPublicNetworkSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: dbaas_postgresql_public_network
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterDBAASPostgreSQLPublicNetworkSerializer
      type: object
    SchemaFilterDBAASPostgreSQLVolumeSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterDBAASPostgreSQLVolumesEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: dbaas_postgresql_volume
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterDBAASPostgreSQLVolumeSerializer
      type: object
    SchemaFilterEgressTrafficSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterEgressTrafficEnum'
          description: Field name to filter by
          examples:
            - vm_id
        type:
          const: egress_traffic
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterEgressTrafficSerializer
      type: object
    SchemaFilterExternalIpSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterExternalIpEnum'
          description: Field name to filter by
          examples:
            - ip_address
        type:
          const: external_ip
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 10.100.178.92
          examples:
            - - 10.100.178.92
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterExternalIpSerializer
      type: object
    SchemaFilterFileShareSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterFileShareEnum'
          description: Field name to filter by
          examples:
            - last_size
        type:
          const: file_share
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - '10'
          examples:
            - - '10'
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterFileShareSerializer
      type: object
    SchemaFilterFloatingIpSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterFloatingIpEnum'
          description: Field name to filter by
          examples:
            - ip_address
        type:
          const: floatingip
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 10.100.178.92
          examples:
            - - 10.100.178.92
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterFloatingIpSerializer
      type: object
    SchemaFilterFunctionsSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterFunctionsEnum'
          description: Field name to filter by
          examples:
            - last_size
        type:
          const: functions
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - '10'
          examples:
            - - '10'
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterFunctionsSerializer
      type: object
    SchemaFilterFunctionsCallsSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterFunctionsCallsEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: functions_calls
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterFunctionsCallsSerializer
      type: object
    SchemaFilterFunctionsTrafficSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterFunctionsTrafficEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: functions_traffic
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterFunctionsTrafficSerializer
      type: object
    SchemaFilterImageSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterImageEnum'
          description: Field name to filter by
          examples:
            - last_size
        type:
          const: image
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - '10'
          examples:
            - - '10'
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterImageSerializer
      type: object
    SchemaFilterInferenceSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterInferenceEnum'
          description: Field name to filter by
          examples:
            - uuid
        type:
          const: inference
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          examples:
            - - 066e202a-fc9a-43f2-a74d-be34afbee5c9
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterInferenceSerializer
      type: object
    SchemaFilterInstanceSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterInstanceEnum'
          description: Field name to filter by
          examples:
            - flavor
        type:
          const: instance
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - g1-standard-1-2
          examples:
            - - g1-standard-1-2
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterInstanceSerializer
      type: object
    SchemaFilterLoadBalancerSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterLoadBalancerEnum'
          description: Field name to filter by
          examples:
            - flavor
        type:
          const: load_balancer
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - lb1-1-2
          examples:
            - - lb1-1-2
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterLoadBalancerSerializer
      type: object
    SchemaFilterLogIndexSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterLogIndexEnum'
          description: Field name to filter by
          examples:
            - last_size
        type:
          const: log_index
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - '10'
          examples:
            - - '10'
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterLogIndexSerializer
      type: object
    SchemaFilterSnapshotSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterSnapshotEnum'
          description: Field name to filter by
          examples:
            - last_size
        type:
          const: snapshot
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - '10'
          examples:
            - - '10'
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterSnapshotSerializer
      type: object
    SchemaFilterVolumeSerializer:
      additionalProperties: false
      properties:
        field:
          $ref: '#/components/schemas/SchemaFilterVolumeEnum'
          description: Field name to filter by
          examples:
            - last_size
        type:
          const: volume
          title: Type
          type: string
        values:
          description: List of field values to filter
          example:
            - '10'
          examples:
            - - '10'
          items:
            type: string
          title: Values
          type: array
      required:
        - type
        - field
        - values
      title: SchemaFilterVolumeSerializer
      type: object
    UsageReportSortingRequestSerializer:
      example:
        - region: asc
      examples:
        - - region: asc
      properties:
        billing_value:
          $ref: '#/components/schemas/SortingDirections'
        first_seen:
          $ref: '#/components/schemas/SortingDirections'
        last_name:
          $ref: '#/components/schemas/SortingDirections'
        last_seen:
          $ref: '#/components/schemas/SortingDirections'
        project:
          $ref: '#/components/schemas/SortingDirections'
        region:
          $ref: '#/components/schemas/SortingDirections'
        type:
          $ref: '#/components/schemas/SortingDirections'
      title: UsageReportSortingRequestSerializer
      type: object
    TagsFilterSerializer:
      description: Represents a filter consisting of multiple tag filtering conditions.
      properties:
        condition_type:
          $ref: '#/components/schemas/TagsFilterConditionTypes'
          default: OR
          description: >-
            Specifies whether conditions are combined using OR (default) or AND
            logic.
        conditions:
          description: A list of tag filtering conditions defining how tags should match.
          example:
            - key: os_version
              strict: true
              value: '9'
            - key: os_type
              strict: true
              value: linux
            - key: os_distro
              strict: true
              value: centos
          examples:
            - - key: os_version
                strict: true
                value: '9'
              - key: os_type
                strict: true
                value: linux
              - key: os_distro
                strict: true
                value: centos
          items:
            $ref: '#/components/schemas/TagsFilterConditionSerializer'
          maxItems: 10
          minItems: 1
          title: Conditions
          type: array
      required:
        - conditions
      title: TagsFilterSerializer
      type: object
    PrebillingResourceTypes:
      description: Resource types for prebilling report
      enum:
        - ai_cluster
        - ai_virtual_cluster
        - backup
        - baremetal
        - basic_vm
        - containers
        - dbaas_postgresql_connection_pooler
        - dbaas_postgresql_cpu
        - dbaas_postgresql_memory
        - dbaas_postgresql_public_network
        - dbaas_postgresql_volume
        - egress_traffic
        - external_ip
        - file_share
        - floatingip
        - functions
        - functions_calls
        - functions_traffic
        - image
        - inference
        - instance
        - load_balancer
        - log_index
        - snapshot
        - volume
      title: PrebillingResourceTypes
      type: string
    ResourceAiClusterSerializer:
      description: |-
        These properties are common for all individual AI clusters
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: bm3-ai-1xlarge-h100-80-8_min
          examples:
            - bm3-ai-1xlarge-h100-80-8_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        flavor:
          description: Flavor of the Baremetal GPU cluster
          example: bm3-ai-1xlarge-h100-80-8
          examples:
            - bm3-ai-1xlarge-h100-80-8
          title: Flavor
          type: string
        last_name:
          description: Name of the AI cluster
          example: ai_cluster_name
          examples:
            - ai_cluster_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        tags:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          description: List of tags
          examples:
            - - os_distro: ubuntu
              - os_version: '22.04'
          title: Tags
        type:
          const: ai_cluster
          title: Type
          type: string
        uuid:
          description: UUID of the Baremetal GPU cluster
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - flavor
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
        - tags
      title: ResourceAiClusterSerializer
      type: object
    ResourceAiVirtualClusterSerializer:
      description: |-
        These properties are common for all individual AI Virtual clusters
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: g3-ai-32-192-1500-l40s-48-1_min
          examples:
            - g3-ai-32-192-1500-l40s-48-1_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        flavor:
          description: Flavor of the Virtual GPU cluster
          example: g3-ai-32-192-1500-l40s-48-1
          examples:
            - g3-ai-32-192-1500-l40s-48-1
          title: Flavor
          type: string
        last_name:
          description: Name of the AI cluster
          example: ai_virtual_cluster_name
          examples:
            - ai_virtual_cluster_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        tags:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          description: List of tags
          examples:
            - - os_distro: ubuntu
              - os_version: '22.04'
          title: Tags
        type:
          const: ai_virtual_cluster
          title: Type
          type: string
        uuid:
          description: UUID of the Virtual GPU cluster
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - flavor
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
        - tags
      title: ResourceAiVirtualClusterSerializer
      type: object
    ResourceBackupSerializer:
      description: |-
        These properties are common for all individual backups
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: backup_gbm
          examples:
            - backup_gbm
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: gbminutes
          description: Unit of billing value
          example: gbminutes
          examples:
            - gbminutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the backup
          example: backup_name
          examples:
            - backup_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        last_size:
          description: Size of the backup in bytes
          example: 46137344
          examples:
            - 46137344
          title: Last Size
          type: integer
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        schedule_id:
          description: ID of the backup schedule
          format: uuid
          title: Schedule Id
          type: string
        source_volume_uuid:
          description: UUID of the source volume
          format: uuid
          title: Source Volume Uuid
          type: string
        type:
          const: backup
          title: Type
          type: string
        uuid:
          description: UUID of the backup
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - last_size
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
        - source_volume_uuid
        - schedule_id
      title: ResourceBackupSerializer
      type: object
    ResourceBaremetalSerializer:
      description: |-
        These properties are common for all individual bare metal servers
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: bm2-hf-medium_min
          examples:
            - bm2-hf-medium_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        flavor:
          description: Flavor of the bare metal server
          example: bm2-hf-medium
          examples:
            - bm2-hf-medium
          title: Flavor
          type: string
        last_name:
          description: Name of the bare metal server
          example: baremetal_name
          examples:
            - baremetal_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        tags:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          description: List of tags
          examples:
            - - os_distro: ubuntu
              - os_version: '22.04'
          title: Tags
        type:
          const: baremetal
          title: Type
          type: string
        uuid:
          description: UUID of the bare metal server
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - flavor
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
        - tags
      title: ResourceBaremetalSerializer
      type: object
    ResourceBasicVmSerializer:
      description: |-
        These properties are common for all individual basic VMs
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: g2s-shared-1-2-25_min
          examples:
            - g2s-shared-1-2-25_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        flavor:
          description: Flavor of the basic VM
          example: g2s-shared-1-2-25
          examples:
            - g2s-shared-1-2-25
          title: Flavor
          type: string
        last_name:
          description: Name of the basic VM
          example: basic_vm_name
          examples:
            - basic_vm_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        tags:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          description: List of tags
          examples:
            - - os_distro: ubuntu
              - os_version: '22.04'
          title: Tags
        type:
          const: basic_vm
          title: Type
          type: string
        uuid:
          description: UUID of the basic VM
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - flavor
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
        - tags
      title: ResourceBasicVmSerializer
      type: object
    ResourceContainerSerializer:
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: caas_container_resources_sec
          examples:
            - caas_container_resources_sec
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: GBS
          description: Unit of billing value
          example: GBS
          examples:
            - GBS
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the container
          example: container_name
          examples:
            - container_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        type:
          const: containers
          title: Type
          type: string
        uuid:
          description: UUID of the container
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
      title: ResourceContainerSerializer
      type: object
    ResourceDBAASPostgreSQLPoolerSerializer:
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: dbaas_postgresql_public_network_min
          examples:
            - dbaas_postgresql_public_network_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the cluster
          example: cluster_name
          examples:
            - cluster_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        type:
          const: dbaas_postgresql_connection_pooler
          title: Type
          type: string
        uuid:
          description: UUID of the cluster
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
      title: ResourceDBAASPostgreSQLPoolerSerializer
      type: object
    ResourceDBAASPostgreSQLCPUSerializer:
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: dbaas_postgresql_cpu_min
          examples:
            - dbaas_postgresql_cpu_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the cluster
          example: cluster_name
          examples:
            - cluster_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        type:
          const: dbaas_postgresql_cpu
          title: Type
          type: string
        uuid:
          description: UUID of the cluster
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
      title: ResourceDBAASPostgreSQLCPUSerializer
      type: object
    ResourceDBAASPostgreSQLMemorySerializer:
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: dbaas_postgresql_memory_gbmin
          examples:
            - dbaas_postgresql_memory_gbmin
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: gbminutes
          description: Unit of billing value
          example: gbminutes
          examples:
            - gbminutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the cluster
          example: cluster_name
          examples:
            - cluster_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        type:
          const: dbaas_postgresql_memory
          title: Type
          type: string
        uuid:
          description: UUID of the cluster
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
      title: ResourceDBAASPostgreSQLMemorySerializer
      type: object
    ResourceDBAASPostgreSQLPublicNetworkSerializer:
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: dbaas_postgresql_public_network_min
          examples:
            - dbaas_postgresql_public_network_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the cluster
          example: cluster_name
          examples:
            - cluster_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        type:
          const: dbaas_postgresql_public_network
          title: Type
          type: string
        uuid:
          description: UUID of the cluster
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
      title: ResourceDBAASPostgreSQLPublicNetworkSerializer
      type: object
    ResourceDBAASPostgreSQLVolumeSerializer:
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: dbaas_postgresql_public_network_min
          examples:
            - dbaas_postgresql_public_network_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: gbminutes
          description: Unit of billing value
          example: gbminutes
          examples:
            - gbminutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the cluster
          example: cluster_name
          examples:
            - cluster_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        size_unit:
          description: Unit of size
          example: GiB
          examples:
            - GiB
          title: Size Unit
          type: string
        type:
          const: dbaas_postgresql_volume
          title: Type
          type: string
        uuid:
          description: UUID of the cluster
          format: uuid
          title: Uuid
          type: string
        volume_type:
          description: Type of the volume
          example: standard
          examples:
            - standard
          title: Volume Type
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - volume_type
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
        - size_unit
      title: ResourceDBAASPostgreSQLVolumeSerializer
      type: object
    ResourceEgressTrafficSerializer:
      description: |-
        These properties are common for all individual egress traffic
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: egress_traffic_baremetal_gbs
          examples:
            - egress_traffic_baremetal_gbs
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: bytes
          description: Unit of billing value
          example: bytes
          examples:
            - bytes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        instance_name:
          anyOf:
            - type: string
            - type: 'null'
          description: Name of the instance
          examples:
            - instance_name
          title: Instance Name
        instance_type:
          $ref: '#/components/schemas/EgressTrafficInstanceType'
          description: Type of the instance
          examples:
            - baremetal
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        port_id:
          description: ID of the port the traffic is associated with
          format: uuid
          title: Port Id
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        size_unit:
          description: Unit of size
          example: bytes
          examples:
            - bytes
          title: Size Unit
          type: string
        tags:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          description: List of tags
          examples:
            - - os_distro: ubuntu
              - os_version: '22.04'
          title: Tags
        type:
          const: egress_traffic
          title: Type
          type: string
        vm_id:
          description: ID of the bare metal server the traffic is associated with
          format: uuid
          title: Vm Id
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - instance_type
        - first_seen
        - last_seen
        - project_id
        - vm_id
        - size_unit
        - port_id
        - instance_name
        - tags
      title: ResourceEgressTrafficSerializer
      type: object
    ResourceExternalIpSerializer:
      description: |-
        These properties are common for all individual external IPs
        in all cost and usage reports results (but not in totals)
      properties:
        attached_to_vm:
          anyOf:
            - format: uuid
              type: string
            - type: 'null'
          description: ID of the VM the IP is attached to
          title: Attached To Vm
        billing_metric_name:
          description: Name of the billing metric
          example: externalip_min
          examples:
            - externalip_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        ip_address:
          description: IP address
          example: 10.100.178.92
          examples:
            - 10.100.178.92
          format: ipvanyaddress
          title: Ip Address
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        network_id:
          description: ID of the network the IP is attached to
          format: uuid
          title: Network Id
          type: string
        port_id:
          description: ID of the port the IP is associated with
          format: uuid
          title: Port Id
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        subnet_id:
          description: ID of the subnet the IP is attached to
          format: uuid
          title: Subnet Id
          type: string
        type:
          const: external_ip
          title: Type
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - port_id
        - attached_to_vm
        - network_id
        - subnet_id
        - ip_address
      title: ResourceExternalIpSerializer
      type: object
    ResourceFileShareSerializer:
      description: |-
        These properties are common for all individual file shares
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: file_share_t_standard_gbm
          examples:
            - file_share_t_standard_gbm
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: gbminutes
          description: Unit of billing value
          example: gbminutes
          examples:
            - gbminutes
          title: Billing Value Unit
          type: string
        file_share_type:
          description: Type of the file share
          example: standard
          examples:
            - standard
          title: File Share Type
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the file share
          example: file_share_name
          examples:
            - file_share_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        last_size:
          description: Size of the file share in bytes
          example: 100
          examples:
            - 100
          title: Last Size
          type: integer
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        size_unit:
          const: GiB
          description: Unit of size
          example: GiB
          examples:
            - GiB
          title: Size Unit
          type: string
        tags:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          description: List of tags
          examples:
            - - os_distro: ubuntu
              - os_version: '22.04'
          title: Tags
        type:
          const: file_share
          title: Type
          type: string
        uuid:
          description: UUID of the file share
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - file_share_type
        - first_seen
        - last_seen
        - project_id
        - last_size
        - size_unit
        - last_name
        - uuid
        - tags
      title: ResourceFileShareSerializer
      type: object
    ResourceFloatingIpSerializer:
      description: |-
        These properties are common for all individual floating IPs
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: floating_min
          examples:
            - floating_min
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: minutes
          description: Unit of billing value
          example: minutes
          examples:
            - minutes
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        ip_address:
          description: IP address
          example: 10.100.178.92
          examples:
            - 10.100.178.92
          format: ipvanyaddress
          title: Ip Address
          type: string
        last_name:
          description: Name of the floating IP
          example: 10.100.178.92
          examples:
            - 10.100.178.92
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        tags:
          anyOf:
            - items:
                additionalProperties:
                  type: string
                type: object
              type: array
            - type: 'null'
          description: List of tags
          examples:
            - - os_distro: ubuntu
              - os_version: '22.04'
          title: Tags
        type:
          const: floatingip
          title: Type
          type: string
        uuid:
          description: UUID of the floating IP
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - ip_address
        - uuid
        - tags
      title: ResourceFloatingIpSerializer
      type: object
    ResourceFunctionsSerializer:
      description: |-
        These properties are common for all individual functions
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: faas_function_resources_sec
          examples:
            - faas_function_resources_sec
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: GBS
          description: Unit of billing value
          example: GBS
          examples:
            - GBS
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the function
          example: function_name
          examples:
            - function_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        type:
          const: functions
          title: Type
          type: string
        uuid:
          description: UUID of the function
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
      title: ResourceFunctionsSerializer
      type: object
    ResourceFunctionCallsSerializer:
      description: |-
        These properties are common for all individual function calls
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: faas_function_calls_piece
          examples:
            - faas_function_calls_piece
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: MLS
          description: Unit of billing value
          example: MLS
          examples:
            - MLS
          title: Billing Value Unit
          type: string
        first_seen:
          description: First time the resource was seen in the given period
          example: '2024-07-01T00:00:30Z'
          examples:
            - '2024-07-01T00:00:30Z'
          format: date-time
          title: First Seen
          type: string
        last_name:
          description: Name of the function call
          example: function_call_name
          examples:
            - function_call_name
          title: Last Name
          type: string
        last_seen:
          description: Last time the resource was seen in the given period
          example: '2024-07-30T23:59:30Z'
          examples:
            - '2024-07-30T23:59:30Z'
          format: date-time
          title: Last Seen
          type: string
        project_id:
          description: ID of the project the resource belongs to
          example: 10
          examples:
            - 10
          title: Project Id
          type: integer
        region:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region
          type: integer
        region_id:
          description: Region ID
          example: 76
          examples:
            - 76
          title: Region Id
          type: integer
        type:
          const: functions_calls
          title: Type
          type: string
        uuid:
          description: UUID of the function call
          format: uuid
          title: Uuid
          type: string
      required:
        - type
        - billing_value
        - billing_value_unit
        - billing_metric_name
        - region
        - region_id
        - first_seen
        - last_seen
        - project_id
        - last_name
        - uuid
      title: ResourceFunctionCallsSerializer
      type: object
    ResourceFunctionEgressTrafficSerializer:
      description: |-
        These properties are common for all individual function egress traffic
        in all cost and usage reports results (but not in totals)
      properties:
        billing_metric_name:
          description: Name of the billing metric
          example: faas_function_egress_traffic_gbs
          examples:
            - faas_function_egress_traffic_gbs
          title: Billing Metric Name
          type: string
        billing_value:
          description: Value of the billing metric
          example: 1000
          examples:
            - 1000
          title: Billing Value
          type: number
        billing_value_unit:
          const: GB
[...]
